var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component } from '@angular/core';
import { Attribute, AttributeColumns, AttributesDefaultSort } from '../../utilities/demoUtilities';
export let AlertDemo = class AlertDemo {
    constructor() {
        this.showAlert = false;
        this.closeDelay = 0;
        this.alertType = "success";
        this.alertBody = "<strong>Some alert</strong> success message or something";
        this.attributes = [
            new Attribute('displayed', 'boolean', 'false', 'Two-way binding to display the alert'),
            new Attribute('closeButton', 'boolean', 'true', "Option to display the 'X' in the right hand corner to close the alert"),
            new Attribute('closeDelay', 'number', '0', 'Number in milliseconds until the alert automatically closes. When set to 0, the alert will stay open until manually closed'),
            new Attribute('type', 'string', 'success', 'The type of alert to display. Default types include success, info, warning, and danger. <a href="http://v4-alpha.getbootstrap.com/components/alerts/#link-color" target="_blank">More info here...</a>'),
        ];
        this.attributesColumns = AttributeColumns;
        this.attributesSort = AttributesDefaultSort;
    }
    showSuccess() {
        this.closeDelay = 0;
        this.alertType = "success";
        this.alertBody = "<strong>Some alert</strong> success message or something";
        this.showAlert = true;
    }
    showError() {
        this.closeDelay = 0;
        this.alertType = "danger";
        this.alertBody = "<strong>Something went wrong</strong> error message or something";
        this.showAlert = true;
    }
    showDelay() {
        this.closeDelay = 5000;
        this.alertType = "info";
        this.alertBody = "<strong>Nice!</strong> This will close in 5 seconds...";
        this.showAlert = true;
    }
    test() {
        console.log("changed");
    }
};
AlertDemo = __decorate([
    Component({
        template: "\n    <div class=\"row\"><div class=\"col-md-12\"><div class=\"card card-block\"><h2 class=\"card-title\">Alert</h2><p class=\"card-text\">Alert is a custom component to display informational messages</p></div></div></div><alert [(displayed)]=\"showAlert\" [type]=\"alertType\" [closeDelay]=\"closeDelay\"><span [innerHtml]=\"alertBody\"></span></alert><button class=\"btn btn-success\" (click)=\"showSuccess()\">Show Alert Success</button> <button class=\"btn btn-danger\" (click)=\"showError()\">Show Alert Error</button> <button class=\"btn btn-info\" (click)=\"showDelay()\">Show Delayed Close Error</button><div class=\"source\"><h3>Import</h3><pre>\n    <code class=\"language-javascript\" code-highlight>\n    import {{'{'}}Alert{{'}'}} from 'fuel-ui/fuel-ui';\n    </code>\n    </pre><h3>Getting Started</h3><p>Alert is a custom element to programmatically display feedback messages typically for user actions</p><h3>Usage</h3><tabset><tab heading=\"HTML\"><pre>\n    <code class=\"language-markup\" code-highlight>\n    &lt;alert [(displayed)]=&quot;showAlert&quot; type=&quot;success&quot; [closeButton]=&quot;false&quot;&gt;\n        &lt;strong&gt;Success!&lt;/strong&gt; Your alert is showing!\n    &lt;/alert&gt;\n    </code>\n    </pre></tab><tab heading=\"TypeScript\"><pre>\n    <code class=\"language-javascript\" code-highlight>\n    export class AlertExample {{'{'}}\n        showAlert: boolean = false;\n    {{'}'}}\n    </code>\n    </pre></tab></tabset><h3>Attributes</h3><table-sortable [columns]=\"attributesColumns\" [data]=\"attributes\" [sort]=\"attributesSort\">Loading table...</table-sortable></div>\n  "
    }), 
    __metadata('design:paramtypes', [])
], AlertDemo);
