var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, ViewEncapsulation } from "@angular/core";
import { Input, Output, EventEmitter } from "@angular/core";
import { DateUtils } from "../../utilities/utilities";
export let DatePickerCalendar = class DatePickerCalendar {
    constructor() {
        this.selectedDateChange = new EventEmitter();
        this.dateTarget = null;
        this.showMonth = true;
    }
    ngOnInit() {
        this.buildWeeks(this.currentMonth || new Date());
    }
    checkSelectable(date) {
        var dateNumber = parseInt(date);
        if (isNaN(dateNumber))
            return false;
        var compareDate = new Date(this.currentMonth.getFullYear(), this.currentMonth.getMonth(), dateNumber);
        if (typeof this.dateFilter == "function" && !this.dateFilter(compareDate))
            return false;
        return compareDate >= this.minDate && compareDate <= this.maxDate;
    }
    checkSelectedDate(date) {
        if (this.selectedDate == null)
            return false;
        if (this.startDate != null && this.endDate != null) {
            let compareDate = new Date(this.currentMonth.getFullYear(), this.currentMonth.getMonth(), parseInt(date));
            return compareDate >= this.startDate && compareDate <= this.endDate;
        }
        return this.selectedDate.getFullYear() == this.currentMonth.getFullYear()
            && this.selectedDate.getMonth() == this.currentMonth.getMonth()
            && this.selectedDate.getDate().toString() == date;
    }
    checkStartDate(date) {
        if (this.endDate == null || !DateUtils.isValidDate(this.startDate) || !DateUtils.isValidDate(this.endDate))
            return false;
        if (this.startDate.getFullYear() == this.endDate.getFullYear()
            && this.startDate.getMonth() == this.endDate.getMonth()
            && this.startDate.getDate().toString() == this.endDate.getDate().toString())
            return false;
        return this.startDate.getFullYear() == this.currentMonth.getFullYear()
            && this.startDate.getMonth() == this.currentMonth.getMonth()
            && this.startDate.getDate().toString() == date;
    }
    checkEndDate(date) {
        if (this.endDate == null || !DateUtils.isValidDate(this.startDate) || !DateUtils.isValidDate(this.endDate))
            return false;
        if (this.startDate.getFullYear() == this.endDate.getFullYear()
            && this.startDate.getMonth() == this.endDate.getMonth()
            && this.startDate.getDate().toString() == this.endDate.getDate().toString())
            return false;
        return this.endDate.getFullYear() == this.currentMonth.getFullYear()
            && this.endDate.getMonth() == this.currentMonth.getMonth()
            && this.endDate.getDate().toString() == date;
    }
    selectDate(date) {
        if (!this.checkSelectable(date))
            return;
        var dateNumber = parseInt(date);
        this.selectedDate = new Date(this.currentMonth.getFullYear(), this.currentMonth.getMonth(), dateNumber);
        this.selectedDateChange.next(this.selectedDate);
    }
    buildWeeks(date) {
        this.currentMonth = date;
        var currentDay = new Date(this.currentMonth.toDateString());
        currentDay.setDate(1);
        currentDay.setDate(currentDay.getDate() - currentDay.getDay());
        var lastDay = new Date(this.currentMonth.getFullYear(), this.currentMonth.getMonth() + 1, 0);
        lastDay.setDate(lastDay.getDate() + (6 - lastDay.getDay()));
        this.weeks = [];
        var currentWeek = [];
        while (currentDay <= lastDay) {
            if (currentDay.getMonth() == this.currentMonth.getMonth())
                currentWeek.push(currentDay.getDate().toLocaleString());
            else
                currentWeek.push("");
            currentDay.setDate(currentDay.getDate() + 1);
            if (currentDay.getDay() == 0) {
                this.weeks.push(currentWeek);
                currentWeek = [];
            }
        }
    }
};
__decorate([
    Input(), 
    __metadata('design:type', Date)
], DatePickerCalendar.prototype, "currentMonth", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Date)
], DatePickerCalendar.prototype, "selectedDate", void 0);
__decorate([
    Output(), 
    __metadata('design:type', Object)
], DatePickerCalendar.prototype, "selectedDateChange", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Boolean)
], DatePickerCalendar.prototype, "dateTarget", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Date)
], DatePickerCalendar.prototype, "startDate", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Date)
], DatePickerCalendar.prototype, "endDate", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Date)
], DatePickerCalendar.prototype, "minDate", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Date)
], DatePickerCalendar.prototype, "maxDate", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Function)
], DatePickerCalendar.prototype, "dateFilter", void 0);
__decorate([
    Input(), 
    __metadata('design:type', Boolean)
], DatePickerCalendar.prototype, "showMonth", void 0);
DatePickerCalendar = __decorate([
    Component({
        selector: "date-picker-calendar",
        template: "\n      <div class=\"fuel-ui-datepicker-calendar text-center py\"><table class=\"table m-a-0\"><tbody><tr *ngIf=\"showMonth\"><td colspan=\"7\"><strong>{{currentMonth | date:'MMMM yyyy'}}</strong></td></tr><tr *ngFor=\"let week of weeks\"><td *ngFor=\"let day of week\" [class.selectable]=\"checkSelectable(day)\" [class.disabled]=\"!checkSelectable(day)\" [class.selected]=\"checkSelectedDate(day)\" [class.startDate]=\"checkStartDate(day)\" [class.endDate]=\"checkEndDate(day)\" (click)=\"selectDate(day)\"><span class=\"calendar-date\">{{day}}</span></td></tr></tbody></table></div>\n    ",
        styles: ["\n      .fuel-ui-datepicker-calendar .table {\n        font-size: .75rem;\n        border: none;\n        border-top: 1px solid #eceeef;\n        background-color: #fff;\n        border-collapse: collapse; }\n        .fuel-ui-datepicker-calendar .table .calendar-date {\n          z-index: 200;\n          background-color: transparent; }\n        .fuel-ui-datepicker-calendar .table tr {\n          border: none; }\n        .fuel-ui-datepicker-calendar .table th, .fuel-ui-datepicker-calendar .table td {\n          text-align: center;\n          vertical-align: middle;\n          font-size: .75rem;\n          padding: .1rem;\n          height: 1.75rem;\n          border: none;\n          position: relative; }\n          @media (max-width: 480px), screen and (max-device-width: 480px) {\n            .fuel-ui-datepicker-calendar .table th, .fuel-ui-datepicker-calendar .table td {\n              padding: .5rem;\n              font-size: 1rem; } }\n        .fuel-ui-datepicker-calendar .table td.selectable {\n          cursor: pointer !important; }\n          .fuel-ui-datepicker-calendar .table td.selectable:hover {\n            background-color: #0275d8;\n            color: #fff; }\n        .fuel-ui-datepicker-calendar .table td.selected {\n          background-color: #99c4e9;\n          color: #fff; }\n        .fuel-ui-datepicker-calendar .table td.disabled {\n          color: #c9c9c9; }\n        .fuel-ui-datepicker-calendar .table td.startDate, .fuel-ui-datepicker-calendar .table td.endDate {\n          background-color: #0275d8;\n          color: #fff; }\n        .fuel-ui-datepicker-calendar .table td.startDate:after {\n          content: '';\n          position: absolute;\n          top: 0;\n          bottom: 0;\n          width: 0;\n          right: 0;\n          background-color: transparent;\n          border-left: 1em solid transparent;\n          border-top: 1.1em solid #99c4e9;\n          border-bottom: 1.1em solid #99c4e9; }\n        .fuel-ui-datepicker-calendar .table td.endDate:before {\n          content: '';\n          position: absolute;\n          top: 0;\n          bottom: 0;\n          width: 0;\n          left: 0;\n          background-color: transparent;\n          border-right: 1em solid transparent;\n          border-top: 1.1em solid #99c4e9;\n          border-bottom: 1.1em solid #99c4e9; }\n    "],
        encapsulation: ViewEncapsulation.None
    }), 
    __metadata('design:paramtypes', [])
], DatePickerCalendar);
