"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var AccordionDemo = (function () {
    function AccordionDemo() {
        this.oneAtATime = true;
        this.duration = 250;
        this.firstOpen = true;
        this.firstDisabled = false;
        this.lastOpen = false;
        this.contentItems = ['Item 1', 'Item 2', 'Item 3'];
        this.accordionItems = [
            {
                heading: 'Custom Object Header - 1',
                content: 'Custom Object Body - 1'
            },
            {
                heading: 'Custom Object Header - 2',
                content: 'Custom Object Body - 2'
            }
        ];
        this.accordionAttributes = [
            new demoUtilities_1.Attribute('closeOthers', 'boolean', 'true', 'Only be able to have one accordion item opened at once'),
            new demoUtilities_1.Attribute('duration', 'number', '250', 'Duration of the collapse animations')
        ];
        this.accordionAttributesColumns = demoUtilities_1.AttributeColumns;
        this.accordionAttributesSort = demoUtilities_1.AttributesDefaultSort;
        this.accordionItemAttributes = [
            new demoUtilities_1.Attribute('disabled', 'boolean', 'false', 'Disable accordion item from opening on click and display as greyed out'),
            new demoUtilities_1.Attribute('open', 'boolean', 'false', 'The status of the accordion item showing content'),
            new demoUtilities_1.Attribute('heading', 'string', 'null', 'The clickable heading of the content of your accordion item')
        ];
        this.accordionItemAttributesColumns = demoUtilities_1.AttributeColumns;
        this.accordionItemAttributesSort = demoUtilities_1.AttributesDefaultSort;
    }
    AccordionDemo.prototype.addContentItem = function () {
        this.contentItems.push('New Item ' + (this.contentItems.length + 1));
    };
    AccordionDemo.prototype.addAccordionItem = function () {
        this.accordionItems.push({
            heading: 'Custom Object Header - ' + (this.accordionItems.length + 1),
            content: 'Custom Object Body - ' + (this.accordionItems.length + 1)
        });
    };
    AccordionDemo = __decorate([
        core_1.Component({
            template: "\n    <div class=\"row\"><div class=\"col-md-12\"><div class=\"card card-block\"><h2 class=\"card-title\">Accordion</h2><p class=\"card-text\">Accordion is a custom component to display a list of collapsable items</p></div></div></div><section class=\"row m-a\"><div><p><button type=\"button\" class=\"btn btn-primary btn-sm\" (click)=\"lastOpen = !lastOpen\">Last Items: {{lastOpen ? 'Opened' : 'Closed'}}</button> <button type=\"button\" class=\"btn btn-primary btn-sm\" (click)=\"firstDisabled = ! firstDisabled\">First panels: {{firstDisabled ? 'Disabled' : 'Enabled'}}</button> <button type=\"button\" class=\"btn btn-primary btn-sm\" (click)=\"addAccordionItem()\">Add Accordion Item</button></p><div class=\"row\"><label for=\"duration\" class=\"col-sm-2 form-control-label\">Animation Duration</label><div class=\"col-sm-2\"><input class=\"form-control\" [(ngModel)]=\"duration\" step=\"10\" type=\"number\" name=\"duration\"></div><div class=\"checkbox col-md-3\"><label for=\"oneAtATime\" class=\"form-control-label\"><input [(ngModel)]=\"oneAtATime\" name=\"oneAtATime\" type=\"checkbox\"> Open only one at a time</label></div></div><div class=\"row\"><div class=\"col-md-6\"><h3>Without Styles</h3><accordion [closeOthers]=\"oneAtATime\" [duration]=\"duration\"><accordion-item heading=\"Static Header 1\" [(open)]=\"firstOpen\" [disabled]=\"firstDisabled\">This content is showing on start</accordion-item><accordion-item *ngFor=\"let accordionItem of accordionItems\" [heading]=\"accordionItem.heading\">{{ accordionItem?.content }}</accordion-item><accordion-item heading=\"Accordion Item Body Expands\"><p>The body of the accordion group expands as the content grows</p><button type=\"button\" class=\"btn btn-primary btn-sm\" (click)=\"addContentItem()\">Add Item</button><div *ngFor=\"let contentItem of contentItems\">{{contentItem}}</div></accordion-item><accordion-item #item [(open)]=\"lastOpen\"><accordion-heading><a (click)=\"$event.preventDefault\" class=\"fuel-ui-clickable\">Markup Here!</a> <i class=\"pull-right fa\" [ngClass]=\"{'fa-chevron-down': item?.open, 'fa-chevron-right': !item || !item.open}\"></i></accordion-heading>What amazing content!</accordion-item></accordion></div><div class=\"col-md-6\"><h3>With Styles</h3><accordion [closeOthers]=\"oneAtATime\" [duration]=\"duration\"><div accordion-item class=\"fuel-ui-accordion\" [(open)]=\"firstOpen\" [disabled]=\"firstDisabled\"><div accordion-heading class=\"fuel-ui-accordion-heading fuel-ui-clickable\" [ngClass]=\"{'text-muted': firstDisabled}\">Static Header 1</div><div class=\"fuel-ui-accordion-body\">This content is showing on start</div></div><div accordion-item class=\"fuel-ui-accordion\" *ngFor=\"let accordionItem of accordionItems\"><div accordion-heading class=\"fuel-ui-accordion-heading fuel-ui-clickable\">{{accordionItem.heading}}</div><div class=\"fuel-ui-accordion-body\">{{ accordionItem?.content }}</div></div><div accordion-item class=\"fuel-ui-accordion\"><div accordion-heading class=\"fuel-ui-accordion-heading fuel-ui-clickable\">Accordion Item Body Expands</div><div class=\"fuel-ui-accordion-body\"><p>The body of the accordion group expands as the content grows</p><button type=\"button\" class=\"btn btn-primary btn-sm\" (click)=\"addContentItem()\">Add Item</button><div *ngFor=\"let contentItem of contentItems\">{{contentItem}}</div></div></div><div accordion-item class=\"fuel-ui-accordion\" #itemStyled [(open)]=\"lastOpen\"><div accordion-heading class=\"fuel-ui-accordion-heading fuel-ui-clickable\"><a (click)=\"$event.preventDefault\">Markup Here!</a> <i class=\"pull-right fa\" [ngClass]=\"{'fa-chevron-down': itemStyled?.open, 'fa-chevron-right': !itemStyled || !itemStyled.open}\"></i></div><div class=\"fuel-ui-accordion-body\">What amazing content!</div></div></accordion><p>The class styles from the example Accordion above are added with Fuel-UI's CSS bundle, so feel free to use the HTML below!</p></div></div></div></section><div class=\"source\"><h3>Import</h3><pre>\n    <code class=\"language-javascript\" code-highlight>\n    import {{'{'}}ACCORDION_PROVIDERS{{'}'}} from 'fuel-ui/fuel-ui';\n    </code>\n    </pre><h3>Getting Started</h3><p>Accordion is a custom element to show a list of collapsable items. The Accordion component makes use of the Collapse directive to make a highly customizable interface.</p><h3>Usage</h3><tabset><tab heading=\"HTML - No Styles\"><pre>\n    <code class=\"language-markup\" code-highlight>\n    &lt;accordion [closeOthers]=&quot;oneAtATime&quot; [duration]=&quot;duration&quot;&gt;\n        &lt;accordion-item heading=&quot;Static Header 1&quot;\n                        [(open)]=&quot;firstOpen&quot;\n                        [disabled]=&quot;firstDisabled&quot;&gt;\n            This content is showing on start\n        &lt;/accordion-item&gt;\n        &lt;accordion-item #item [(open)]=&quot;lastOpen&quot;&gt;\n            &lt;accordion-heading&gt;\n                &lt;a (click)=&quot;$event.preventDefault&quot; class=&quot;fuel-ui-clickable&quot;&gt;Markup Here!&lt;/a&gt;\n                &lt;i class=&quot;pull-right fa&quot;\n                    [ngClass]=&quot;{{'{'}}'fa-chevron-down': item?.open, 'fa-chevron-right': !item || !item.open{{'}'}}&quot;&gt;&lt;/i&gt;\n            &lt;/accordion-heading&gt;\n            What amazing content!\n        &lt;/accordion-item&gt;\n    &lt;/accordion&gt;\n    </code>\n    </pre></tab><tab heading=\"HTML - With Styles\"><pre>\n    <code class=\"language-markup\" code-highlight>\n    &lt;accordion [closeOthers]=&quot;oneAtATime&quot; [duration]=&quot;duration&quot;&gt;\n        &lt;div accordion-item class=&quot;fuel-ui-accordion&quot;\n                        [(open)]=&quot;firstOpen&quot;\n                        [disabled]=&quot;firstDisabled&quot;&gt;\n            &lt;div accordion-heading class=&quot;fuel-ui-accordion-heading fuel-ui-clickable&quot; \n                        [ngClass]=&quot;{{'{'}}'text-muted': firstDisabled{{'}'}}&quot;&gt;\n                Static Header 1\n            &lt;/div&gt;\n            &lt;div class=&quot;fuel-ui-accordion-body&quot;&gt;\n                This content is showing on start\n            &lt;/div&gt;\n        &lt;/div&gt;\n        &lt;div accordion-item class=&quot;fuel-ui-accordion&quot; #itemStyled [(open)]=&quot;lastOpen&quot;&gt;\n            &lt;div accordion-heading class=&quot;fuel-ui-accordion-heading fuel-ui-clickable&quot;&gt;\n                &lt;a (click)=&quot;$event.preventDefault&quot;&gt;Markup Here!&lt;/a&gt;\n                &lt;i class=&quot;pull-right fa&quot;\n                    [ngClass]=&quot;{{'{'}}'fa-chevron-down': itemStyled?.open, 'fa-chevron-right': !itemStyled || !itemStyled.open{{'}'}}&quot;&gt;&lt;/i&gt;\n            &lt;/div&gt;\n            &lt;div class=&quot;fuel-ui-accordion-body&quot;&gt;\n                What amazing content!\n            &lt;/div&gt;\n        &lt;/div&gt;\n    &lt;/accordion&gt;\n    </code>\n    </pre></tab><tab heading=\"Sass\"><pre>\n    <code class=\"language-css\" code-highlight>\n    /* \n     * This is added in Fuel-UI's CSS bundle already!\n     * Feel free to use this as base for your own styles!\n     */\n\n    .fuel-ui-accordion {{'{'}}\n        background-color: #fff;\n        border: 1px solid #ddd;\n        border-radius: 4px;\n    \n        .fuel-ui-accordion-heading {{'{'}}\n            background-color: #f5f5f5;\n            border-bottom: 1px solid #ddd;\n            border-top-left-radius: 3px;\n            border-top-right-radius: 3px;\n            color: #333;\n            padding: 10px 15px;\n        \n            &.text-muted {{'{'}}\n                color: #818a91 !important;\n            {{'}'}}\n        {{'}'}}\n    \n        .fuel-ui-accordion-body {{'{'}}\n            padding: 15px;\n        {{'}'}}\n    {{'}'}}\n    </code>\n    </pre></tab><tab heading=\"TypeScript\"><pre>\n    <code class=\"language-javascript\" code-highlight>\n    export class AccordionExample {{'{'}}\n        oneAtATime:boolean = true;\n        duration:number = 250;\n        firstOpen:boolean = true;\n        firstDisabled:boolean = false;\n        lastOpen:boolean = false;\n    {{'{'}}\n    </code>\n    </pre></tab></tabset><h3>Accordion Attributes</h3><table-sortable [columns]=\"accordionAttributesColumns\" [data]=\"accordionAttributes\" [sort]=\"accordionAttributesSort\">Loading table...</table-sortable><h3>Accordion Item Attributes</h3><table-sortable [columns]=\"accordionItemAttributesColumns\" [data]=\"accordionItemAttributes\" [sort]=\"accordionItemAttributesSort\">Loading table...</table-sortable></div>\n  "
        }), 
        __metadata('design:paramtypes', [])
    ], AccordionDemo);
    return AccordionDemo;
}());
exports.AccordionDemo = AccordionDemo;

//# sourceMappingURL=Accordion.Demo.js.map
