"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var TextExpanderDemo = (function () {
    function TextExpanderDemo() {
        this.expanded = false;
        this.ellipsis = true;
        this.text = "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum sed massa sed odio gravida iaculis. Sed elementum dapibus neque, sit.";
        this.characters = 50;
        this.words = 0;
        this.expandText = "Show more";
        this.shrinkText = "Show less";
        this.attributes = [
            new demoUtilities_1.Attribute('expanded', 'boolean', 'false', 'The current state of whether or not the complete text is displayed'),
            new demoUtilities_1.Attribute('ellipsis', 'boolean', 'true', 'Add "..." at the end of the text when not expanded'),
            new demoUtilities_1.Attribute('text', 'string', 'null', 'The text that can be expanded/shrunk'),
            new demoUtilities_1.Attribute('characters', 'number', '50', 'The number of characters displayed when text is shrunk'),
            new demoUtilities_1.Attribute('words', 'number', '0', 'The number of words displayed when text is shrunk. If set to 0, characters are defaulted to'),
            new demoUtilities_1.Attribute('expandText', 'string', 'show more', 'Clickable text used to expand text'),
            new demoUtilities_1.Attribute('shrinkText', 'string', 'show less', 'Clickable text used to shrink text')
        ];
        this.attributesColumns = demoUtilities_1.AttributeColumns;
        this.attributesSort = demoUtilities_1.AttributesDefaultSort;
        this.events = [
            new demoUtilities_1.Event('expandedChange', '$event = expanded: boolean', 'New state of whether the text is expanded or not')
        ];
        this.eventsColumns = demoUtilities_1.EventColumns;
        this.eventsSort = demoUtilities_1.EventsDefaultSort;
    }
    TextExpanderDemo = __decorate([
        core_1.Component({
            template: "\n    <div class=\"row\"><div class=\"col-md-12\"><div class=\"card card-block\"><h2 class=\"card-title\">TextExpander</h2><p class=\"card-text\">TextExpander is a custom component to display a text expander number list</p></div></div></div><section class=\"row m-a\"><div class=\"col-md-8\"><form><div class=\"form-group row\"><label for=\"text\" class=\"col-sm-2 form-control-label\">Text</label><div class=\"col-sm-12\"><input class=\"form-control\" [(ngModel)]=\"text\" name=\"text\"></div></div><div class=\"form-group row\"><label for=\"characters\" class=\"col-sm-2 form-control-label\">Characters</label><div class=\"col-sm-2\"><input class=\"form-control\" [(ngModel)]=\"characters\" min=\"1\" type=\"number\" name=\"characters\"></div></div><div class=\"form-group row\"><label for=\"words\" class=\"col-sm-2 form-control-label\">Words</label><div class=\"col-sm-2\"><input class=\"form-control\" [(ngModel)]=\"words\" min=\"0\" type=\"number\" name=\"words\"></div><small class=\"text-muted\">Expander defaults to number of characters when set to 0.</small></div><div class=\"form-group row\"><label for=\"expandText\" class=\"col-sm-2 form-control-label\">Expand Text</label><div class=\"col-sm-6\"><input class=\"form-control\" [(ngModel)]=\"expandText\" name=\"expandText\"></div></div><div class=\"form-group row\"><label for=\"expandText\" class=\"col-sm-2 form-control-label\">Shrink Text</label><div class=\"col-sm-6\"><input class=\"form-control\" [(ngModel)]=\"shrinkText\" name=\"shrinkText\"></div></div><div class=\"row\"><div class=\"checkbox col-md-3\"><label for=\"expanded\" class=\"form-control-label\"><input [(ngModel)]=\"expanded\" type=\"checkbox\" name=\"expanded\"> Expanded</label></div></div><div class=\"row\"><div class=\"checkbox col-md-3\"><label for=\"ellipsis\" class=\"form-control-label\"><input [(ngModel)]=\"ellipsis\" type=\"checkbox\" name=\"ellipsis\"> Ellipsis</label></div></div></form><text-expander [(expanded)]=\"expanded\" [ellipsis]=\"ellipsis\" [text]=\"text\" [characters]=\"characters\" [words]=\"words\" [expandText]=\"expandText\" [shrinkText]=\"shrinkText\"></text-expander></div></section><div class=\"source\"><h3>Import</h3><pre>\n    <code class=\"language-javascript\" code-highlight>\n    import {{'{'}}TextExpander{{'}'}} from 'fuel-ui/fuel-ui';\n    </code>\n    </pre><h3>Getting Started</h3><p>TextExpander is a custom element to show an interactive list of page numbers to use for paging</p><h3>Usage</h3><tabset><tab heading=\"HTML\"><pre>\n    <code class=\"language-markup\" code-highlight>\n    &lt;text-expander\n        [(expanded)]=&quot;expanded&quot;\n        [ellipsis]=&quot;ellipsis&quot;\n        [text]=&quot;text&quot;\n        [words]=&quot;words&quot;\n        [characters]=&quot;characters&quot;\n        [expandText]=&quot;expandText&quot;\n        [shrinkText]=&quot;shrinkText&quot;&gt;\n    &lt;/text-expander&gt;\n    </code>\n    </pre></tab><tab heading=\"TypeScript\"><pre>\n    <code class=\"language-javascript\" code-highlight>\n    export class TextExpanderExample {{'{'}}\n        expanded: boolean = false;\n        ellipsis: boolean = true;\n        text: string = \"Lorem ipsum dolor sit amet, consectetur adipiscing elit. Vestibulum sed \" + \n                        \"massa sed odio gravida iaculis. Sed elementum dapibus neque, sit.\";\n        characters: number = 50;\n        words: number = 0;\n        expandText: string = \"Show more\";\n        shrinkText: string = \"Show less\";\n    {{'}'}}\n    </code>\n    </pre></tab></tabset><h3>Attributes</h3><table-sortable [columns]=\"attributesColumns\" [data]=\"attributes\" [sort]=\"attributesSort\">Loading table...</table-sortable><h3>Events</h3><table-sortable [columns]=\"eventsColumns\" [data]=\"events\" [sort]=\"eventsSort\">Loading table...</table-sortable></div>\n  "
        }), 
        __metadata('design:paramtypes', [])
    ], TextExpanderDemo);
    return TextExpanderDemo;
}());
exports.TextExpanderDemo = TextExpanderDemo;

//# sourceMappingURL=TextExpander.Demo.js.map
