"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var demoUtilities_1 = require('../../utilities/demoUtilities');
var TooltipDemo = (function () {
    function TooltipDemo() {
        this.codeExample1 = "&lt;a href=&quot;#&quot; tooltip=&quot;Tooltip text goes here.&quot; \n    [position]=&quot;position&quot; [color]=&quot;color&quot; [size]=&quot;size&quot;\n    [rounded]=&quot;rounded&quot; [always]=&quot;always&quot;&gt;\n    Some text here.\n&lt;/a&gt;\n\n&lt;div class=&quot;col-md-4 form-group&quot;&gt;\n    &lt;div tooltip=&quot;You have entered: {{tooltipText}}!&quot; \n                [position]=&quot;position&quot; [color]=&quot;color&quot; [size]=&quot;size&quot;\n                [rounded]=&quot;rounded&quot; [always]=&quot;always&quot;&gt;\n        &lt;input [(ngModel)]=&quot;tooltipText&quot; type=&quot;text&quot; class=&quot;form-control&quot; placeholder=&quot;Tooltip text&quot; /&gt; \n    &lt;/div&gt;\n    &lt;small class=&quot;text-muted&quot;&gt;Enter text above, then hover the input.&lt;/small&gt;\n&lt;/div&gt;";
        this.attributes = [
            new demoUtilities_1.Attribute('tooltip', 'string', 'null', 'Text of the tooltip'),
            new demoUtilities_1.Attribute('position', 'string', 'top', "Position of the tooltip compared to the element. Allows for: 'bottom-right', 'bottom', 'bottom-left', 'right', 'left', 'top-right,' 'top', or 'top-left'"),
            new demoUtilities_1.Attribute('color', 'string', 'none', "Color of tooltip. Allows for: 'error', 'info', 'success', and 'warning'. Using anything else, include 'none', will result in the default black background with white text"),
            new demoUtilities_1.Attribute('rounded', 'boolean', 'false', 'Rounded edges of tooltip'),
            new demoUtilities_1.Attribute('always', 'boolean', 'false', 'Tooltip always displays even on mouseout and unfocus'),
            new demoUtilities_1.Attribute('size', 'string', 'auto', "Forced size of the tooltip. Allows for: 'small', 'medium', and 'large'. Anything else will cause the tooltip to shrink to fit, and stay on a single line."),
        ];
        this.attributesColumns = demoUtilities_1.AttributeColumns;
        this.attributesSort = demoUtilities_1.AttributesDefaultSort;
        this.position = "top";
        this.color = "none";
        this.size = "auto";
        this.rounded = false;
        this.always = false;
    }
    TooltipDemo = __decorate([
        core_1.Component({
            template: "\n    <div class=\"row\"><div class=\"col-md-12\"><div class=\"card card-block\"><h2 class=\"card-title\">Tooltip</h2><p class=\"card-text\">Tooltip is a directive that causes a tooltip to display on the elements when it is focused on your hovered over</p></div></div></div><section class=\"row m-a\"><div class=\"row\"><div class=\"col-md-3\"><a href=\"javascript:;\" tooltip=\"Tooltip text goes here.\" [position]=\"position\" [color]=\"color\" [size]=\"size\" [rounded]=\"rounded\" [always]=\"always\">Some text here.</a></div><div class=\"col-md-4 form-group\"><div tooltip=\"You have entered: {{tooltipText}}!\" [position]=\"position\" [color]=\"color\" [size]=\"size\" [rounded]=\"rounded\" [always]=\"always\"><input [(ngModel)]=\"tooltipText\" name=\"tooltipText\" class=\"form-control\" placeholder=\"Tooltip text\"></div><small class=\"text-muted\">Enter text above, then hover the input.</small></div></div><br><form><div class=\"form-group row\"><label for=\"position\" class=\"col-sm-2 col-md-1 form-control-label\">Position</label><div class=\"col-sm-2\"><select [(ngModel)]=\"position\" class=\"custom-select\" name=\"position\"><option value=\"bottom-right\">bottom-right</option><option value=\"bottom\">bottom</option><option value=\"bottom-left\">bottom-left</option><option value=\"right\">right</option><option value=\"left\">left</option><option value=\"top-right\">top-right</option><option value=\"top\">top</option><option value=\"top-left\">top-left</option></select></div></div><div class=\"form-group row\"><label for=\"color\" class=\"col-sm-2 col-md-1 form-control-label\">Color</label><div class=\"col-sm-2\"><select [(ngModel)]=\"color\" class=\"custom-select\" name=\"color\"><option value=\"none\">none</option><option value=\"error\">error</option><option value=\"warning\">warning</option><option value=\"info\">info</option><option value=\"success\">success</option></select></div></div><div class=\"form-group row\"><label for=\"size\" class=\"col-sm-2 col-md-1 form-control-label\">Size</label><div class=\"col-sm-2\"><select [(ngModel)]=\"size\" class=\"custom-select\" name=\"size\"><option value=\"auto\">auto</option><option value=\"small\">small</option><option value=\"medium\">medium</option><option value=\"large\">large</option></select></div></div><div class=\"form-group row\"><label for=\"rounded\" class=\"form-control-label\">Rounded</label><input #roundedcb type=\"checkbox\" (change)=\"rounded = roundedcb.checked\" [checked]=\"rounded\"></div><div class=\"form-group row\"><label for=\"always\" class=\"form-control-label\">Always Showing</label><input #alwayscb type=\"checkbox\" (change)=\"always = alwayscb.checked\" [checked]=\"always\"></div></form></section><div class=\"source\"><h3>Import</h3><pre>\n    <code class=\"language-javascript\" code-highlight>\n    {{'import {Tooltip} from \"fuel-ui/fuel-ui\"'}}\n    </code>\n    </pre><h3>Getting Started</h3><p>Tooltip directive makes it easy to add a tooltip to any element. Inputs must be wrapped in a span or div to properly display. Inputs are not containers; therefore, cannot use :before and :after pseudo-elements.</p><h3>Usage</h3><tabset><tab heading=\"HTML\"><pre>\n    <code class=\"language-markup\" code-highlight [innerHTML]=\"codeExample1\">\n    </code>\n    </pre></tab><tab heading=\"TypeScript\"><pre>\n    <code class=\"language-javascript\" code-highlight>\n    export class TooltipExample {{'{'}}\n        position: string = \"top\";\n        color: string = \"none\";\n        size: string = \"auto\";\n        rounded: boolean = false;\n        always: boolean = false;\n    {{'}'}}\n    </code>\n    </pre></tab></tabset><h3>Attributes</h3><table-sortable [columns]=\"attributesColumns\" [data]=\"attributes\" [sort]=\"attributesSort\">Loading table...</table-sortable></div>\n  "
        }), 
        __metadata('design:paramtypes', [])
    ], TooltipDemo);
    return TooltipDemo;
}());
exports.TooltipDemo = TooltipDemo;

//# sourceMappingURL=Tooltip.Demo.js.map
